/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.TypePegawaiDto;
import com.portofolio.service.TypePegawaiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/typePegawai")
public class TypePegawaiController extends LocaleController {
    @Lazy
	@Autowired
    private TypePegawaiService typePegawaiService;
    
    
    @ApiOperation("Api Untuk Menyimpan TypePegawai")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody TypePegawaiDto entity,HttpServletRequest request) {
        Map<String, Object> result = typePegawaiService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update TypePegawai")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdTypePegawai", required = true) Integer kdTypePegawai,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody TypePegawaiDto entity, HttpServletRequest request) {
        Map<String, Object> result = typePegawaiService.update(entity,kdTypePegawai,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus TypePegawai Berdasarkan KdTypePegawai")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdTypePegawai", required = true) Integer kdTypePegawai,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = typePegawaiService.deleteById(kdTypePegawai, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua TypePegawai")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaTypePegawai") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaTypePegawai", required = false) String namaTypePegawai,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = typePegawaiService.grid(page, rows, sort, dir, namaTypePegawai,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan TypePegawai Berdasarkan kdTypePegawai")
    @GetMapping("/findByKdTypePegawai")
    public ResponseEntity<Map<String, Object>> findByKdTypePegawai(
    		@RequestParam(value = "kdTypePegawai", required = true) Integer kdTypePegawai, 
    		HttpServletRequest request) {
        Map<String, Object> result = typePegawaiService.findByKdTypePegawai(kdTypePegawai);
        return RestUtil.getJsonResponse(result);
    }


}
